import { useRoutes, Outlet, BrowserRouter } from 'react-router-dom'
import Films from './pages/Films'
import FilmPage from './pages/FilmPage'
import Header from './pages/components/Header'
import Footer from './pages/components/Footer'
import SearchSame from './pages/SearchSame'
import Registration from './pages/Registration'
import Sessions from './pages/Sessions'
import Orders from './pages/Orders'

function Router(props) {
  return useRoutes(props.rootRoute);
}

export default function App() {
  const routes = [
    { index: true, element: <Films /> },
    { path: '/films', element: <Films />, label: 'Главная' },
    { path: '/registration', element: <Registration />, label: 'Регистрация' },
    { path: '/sessions', element: <Sessions />, label: 'Сеансы' },
    { path: '/orders', element: <Orders />, label: 'Заказы' },
    { path: '/films/:id', element: <FilmPage /> },
    { path: '/search-same/:request', element: <SearchSame /> }
  ];
  const links = routes.filter(route => route.hasOwnProperty('label'));
  const rootRoute = [
    { path: '/', element: render(links), children: routes }
  ];

  function render(links) {
    return (
      <>
        <Header links={links} />
          <Outlet />
        <Footer />
      </>
    );
  }

  return (
    <BrowserRouter>
      <Router rootRoute={ rootRoute } />
    </BrowserRouter>
  );
}