import { React, useState, useEffect } from 'react'
import FilmItem from './components/FilmItem'
import { useParams, useNavigate } from "react-router-dom";
import ContentBlock from './components/ContentBlock';

export default function SearchSame() {
    const navigate = useNavigate();
    // массив полученных фильмов
    const [searchResult, setSearchResult] = useState([]);
    const params = useParams()
    const [items, setItems] = useState([])

    useEffect(() => {
        let temp = JSON.stringify(searchResult);
        temp = JSON.parse(temp);
        setItems(temp);
    }, [searchResult, params]);

    useEffect(() => {
        const fetchData = async () => {
            const url = new URL(`http://localhost:8080/cinema/search?request=${params.request}`)
            try {
                const response = await fetch(url.href);
                const json = await response.json();
                setSearchResult(json);
                console.info('Search success');
            } catch (error) {
                return;
            }
        };
        fetchData();
    }, [])

    const Content = (
        <table className="table" id="tbl-items">
            <tbody>
                {items.map((item) =>
                    <FilmItem
                        item={item}
                        key={item.id}
                        openFilmPageFunc={(index) => navigate(`/films/${index}`)}
                    />
                )}
            </tbody>
        </table>
    )

    return (
        <div>
            <ContentBlock valueBlock={Content} title='Похожие результаты'/>
        </div>
    )
}
