import { React, useEffect, useState } from 'react'
import { useNavigate } from 'react-router-dom'
import banner1 from '../../images/banner1.jpg'
import banner2 from '../../images/banner2.jpg'
import banner3 from '../../images/banner3.jpg'

export default function Banner() {
    const length = 3;
    var old = 0;
    var current = 1;
    const navigate = useNavigate();
    const [bannerState, setBannerState] = useState(['show', 'hide', 'hide']);

    useEffect(() => {
        const timer = window.setInterval(() => {
            setBannerState([...bannerState, bannerState[current] = 'show', bannerState[old] = 'hide']);

            console.info('Banner changed');

            old = current;
            current++;

            if (current === length) {
                current = 0;
            }
        }, 5000)

        return () => {
            window.clearInterval(timer);
        }
    }, [])

    return (
        <div className="d-flex align-items-center flex-column" id="banner">
            <a className={bannerState[0]} onClick={() => navigate("/films/0")} style={{ cursor: "pointer" }}>
                <img src={banner1} /> 
            </a>
            <a className={bannerState[1]} onClick={() => navigate("/films/0")} style={{ cursor: "pointer" }}>
                <img src={banner2} /> 
            </a>
            <a className={bannerState[2]} onClick={() => navigate("/films/0")} style={{ cursor: "pointer" }}>
                <img src={banner3} /> 
            </a>
        </div>
    )
}