import React from "react"
import '../../styles/styleFilmItem.css'
import MyButton from './MyButton'

export default function FilmItem(props) {
    return (
        <tr>
            <td>
                <img className="posterItem me-3" src={props.item.image} alt={props.item.name} align="left" />
                <div className="d-flex flex-row flex-wrap  flex-grow-1 align-items-center">
                    <div className="pt-3 description d-flex flex-column justify-content-start align-items-center mb-3 fs-6 fw-bold">
                        <p className="text-start description">
                            <a className="text-white fs-5 fw-bold pt-3" onClick={() => props.openFilmPageFunc(props.item.id)} style={{ cursor: "pointer" }}>
                                {props.item.name}
                            </a>
                        </p>
                    </div>
                    <div id="rightPanel" className="d-flex flex-wrap justify-content-end text-white fw-bold fs-4 flex-grow-1">
                        <div className="rounded p-1 mx-2 green-mark">9.2</div>
                        <MyButton value={props}/>
                    </div>
                </div>
                <hr className="border border-0 bg-black" />
            </td>
        </tr>
    )
}