import { React, useState } from 'react'
import { useNavigate } from 'react-router-dom'
import searchImage from '../../images/search.jpg'
import '../../styles/styleHeader.css'

export default function Header() {
    const navigate = useNavigate();

    const [searchName, setSearchName] = useState('');

    function handleSubmit(e) {
        console.info('Try to search data');
        e.preventDefault();
        navigate(`/search-same/${searchName}`)
        setSearchName('');
    }

    return (
        <div>
            <header className="fs-4 fw-bold p-1">
                <nav className="navbar navbar-expand-md navbar-dark">
                    <div className="container-fluid">
                        <button className="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target="#navbarNav" aria-controls="navbarNav" aria-expanded="false" aria-label="Toggle navigation">
                            <span className="navbar-toggler-icon"></span>
                        </button>
                        <div className="navbar-collapse collapse justify-content-end" id="navbarNav">
                            <div id="main"> <a onClick={() => navigate("/films")} className="text-decoration-none mx-5" style={{ cursor: "pointer" }}>Главная</a></div>
                            <form onSubmit={handleSubmit} className="col d-flex align-items-center needs-validation">
                                <input value={searchName} onChange={e => setSearchName(e.target.value)} className="form-control mainInput" type="text" name="text" search="true" rounded="true" required placeholder="Введите название" />
                                <button className="border border-0 p-0 ms-2" type="submit"><img className="icon" src={searchImage} alt="Поиск" /></button>
                            </form>
                            <div className="d-flex justify-content-end flex-grow-1 navbar-nav">
                                <a onClick={() => navigate("/registration")} className="text-decoration-none mx-3" style={{ cursor: "pointer" }}>Регистрация</a>
                                <a onClick={() => navigate("/orders")} className="text-decoration-none mx-3" style={{ cursor: "pointer" }}>Заказы</a>
                                <a onClick={() => navigate("/sessions")} className="text-decoration-none mx-3" style={{ cursor: "pointer" }}>Сеансы</a>
                            </div>
                        </div>
                    </div>
                </nav>
            </header>
        </div>
    )
}
