package com.labwork1.app.student.controller;

import com.labwork1.app.student.model.Customer;
import com.labwork1.app.student.model.Order;
import com.labwork1.app.student.model.OrderSession;
import com.labwork1.app.student.model.UserRole;

import java.util.ArrayList;
import java.util.List;

public class CustomerDto {
    private long id;
    private String login;
    private String password;
    private List<OrderDto> orders;
    private UserRole role;

    public CustomerDto() {
    }

    public CustomerDto(Customer customer) {
        this.id = customer.getId();
        this.login = customer.getLogin();
        this.password = customer.getPassword();
        this.orders = new ArrayList<>();
        this.role = customer.getRole();
        if (customer.getOrders() != null) {
            orders = customer.getOrders().stream()
                    .map(OrderDto::new).toList();
        }
    }

    public void setId(long id) {
        this.id = id;
    }

    public void setLogin(String login) {
        this.login = login;
    }

    public void setPassword(String password) {
        this.password = password;
    }

    public void setOrders(List<OrderDto> orders) {
        this.orders = orders;
    }

    public long getId() {
        return id;
    }

    public String getLogin() {
        return login;
    }

    public String getPassword() {
        return password;
    }

    public List<OrderDto> getOrders() {
        return orders;
    }

    public UserRole getRole() {
        return role;
    }
}
