package com.labwork1.app.student.controller;

import com.labwork1.app.student.model.Customer;
import com.labwork1.app.student.model.Order;
import com.labwork1.app.student.model.OrderSession;

import java.sql.Date;
import java.util.List;

public class OrderDto {
    private long id;
    private Date dateOfPurchase;
    private Long customerId;
    private String customer;
    private List<OrderSessionDto> sessions;

    public OrderDto() {
    }

    public OrderDto(Order order) {
        this.id = order.getId();
        this.dateOfPurchase = order.getDateOfPurchase();
        this.customerId = order.getCustomer().getId();
        this.customer = order.getCustomer().getLogin();
        if (order.getSessions() != null && order.getSessions().size() > 0)
            this.sessions = order.getSessions()
                    .stream()
                    .map(x -> new OrderSessionDto(new SessionDto(x.getSession()),
                            x.getId().getOrderId(), x.getCount())).toList();
    }

    public Long getCustomerId() {
        return customerId;
    }

    public void setCustomerId(Long customerId) {
        this.customerId = customerId;
    }

    public void setId(long id) {
        this.id = id;
    }

    public void setDateOfPurchase(Date dateOfPurchase) {
        this.dateOfPurchase = dateOfPurchase;
    }

    public void setCustomer(String customer) {
        this.customer = customer;
    }

    public void setSessions(List<OrderSessionDto> sessions) {
        this.sessions = sessions;
    }

    public long getId() {
        return id;
    }

    public Date getDateOfPurchase() {
        return dateOfPurchase;
    }

    public String getCustomer() {
        return customer;
    }

    public List<OrderSessionDto> getSessions() {
        return sessions;
    }
}
