package com.labwork1.app.student.controller;

import com.labwork1.app.student.model.Session;
import com.labwork1.app.student.model.SessionExtension;
import org.springframework.format.annotation.DateTimeFormat;

import java.time.LocalDateTime;

public class SessionDto {
    private long id;
    private Double price;
    @DateTimeFormat(pattern = "yyyy-MM-dd'T'HH:mm")
    private LocalDateTime timestamp;
    private CinemaDto cinema;
    private Long capacity;
    private int maxCount;

    public SessionDto() {
    }

    public SessionDto(SessionExtension session) {
        this.id = session.getId();
        this.price = session.getPrice();
        this.timestamp = session.getTimestamp();
        this.capacity = session.getCapacity();
        this.maxCount = session.getMaxCount();
        if (session.getCinema() != null) {
            this.cinema = new CinemaDto(session.getCinema());
        } else this.cinema = null;
    }

    public SessionDto(Session session) {
        this.id = session.getId();
        this.price = session.getPrice();
        this.timestamp = session.getTimestamp();
        this.maxCount = session.getMaxCount();
        if (session.getCinema() != null) {
            this.cinema = new CinemaDto(session.getCinema());
        } else this.cinema = null;
    }

    public CinemaDto getCinema() {
        return cinema;
    }

    public void setCinema(CinemaDto cinema) {
        this.cinema = cinema;
    }

    public long getId() {
        return id;
    }

    public void setId(long id) {
        this.id = id;
    }

    public Double getPrice() {
        return price;
    }

    public void setPrice(Double price) {
        this.price = price;
    }

    public LocalDateTime getTimestamp() {
        return timestamp;
    }

    public void setTimestamp(LocalDateTime timestamp) {
        this.timestamp = timestamp;
    }

    public Long getCapacity() {
        return capacity;
    }

    public void setCapacity(Long capacity) {
        this.capacity = capacity;
    }

    public int getMaxCount() {
        return maxCount;
    }

    public void setMaxCount(int maxCount) {
        this.maxCount = maxCount;
    }
}
