package com.labwork1.app.student.model;

import jakarta.persistence.*;

@Entity
@Table(name = "order_session")
public class OrderSession {
    @EmbeddedId
    private OrderSessionKey id;
    @ManyToOne
    @MapsId("sessionId")
    @JoinColumn(name = "session_id")
    private Session session;
    @ManyToOne
    @MapsId("orderId")
    @JoinColumn(name = "order_id")
    private Order order;
    @Column(name = "count")
    private Integer count;

    public OrderSession() {
    }

    public OrderSession(Order order, Session session, Integer count) {
        this.order = order;
        this.session = session;
        this.count = count;
        this.id = new OrderSessionKey(session.getId(), order.getId());
    }

    public OrderSessionKey getId() {
        return id;
    }

    public void setId(OrderSessionKey id) {
        this.id = id;
    }

    public Order getOrder() {
        return order;
    }

    public void setOrder(Order order) {
        this.order = order;
    }

    public Session getSession() {
        return session;
    }

    public void setSession(Session session) {
        this.session = session;
    }

    public Integer getCount() {
        return count;
    }

    public void setCount(Integer count) {
        this.count = count;
    }
}
