package com.labwork1.app.student.repository;

import com.labwork1.app.student.model.Session;
import com.labwork1.app.student.model.SessionExtension;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;

import java.util.List;
import java.util.Optional;

public interface SessionRepository extends JpaRepository<Session, Long> {
    @Query("Select sum(os.count) from OrderSession os where os.session.id = :sessionId")
    Optional<Integer> getCapacity(@Param("sessionId") Long sessionId);
    @Query("Select new com.labwork1.app.student.model.SessionExtension(s, sum(os.count)) from Session s " +
            "left join OrderSession os on s.id = os.session.id " +
            "group by s")
    List<SessionExtension> getSessionsWithCapacity();
    @Query("Select new com.labwork1.app.student.model.SessionExtension(s, sum(os.count)) from Session s " +
            "left join OrderSession os on s.id = os.session.id " +
            "where s.id = :sessionId " +
            "group by s")
    Optional<SessionExtension> getSessionWithCapacity(@Param("sessionId") Long sessionId);
}
