//package com.labwork1.app;
//
//import com.labwork1.app.student.model.*;
//import com.labwork1.app.student.service.*;
//import org.junit.jupiter.api.Assertions;
//import org.junit.jupiter.api.Test;
//import org.slf4j.Logger;
//import org.slf4j.LoggerFactory;
//import org.springframework.beans.factory.annotation.Autowired;
//import org.springframework.boot.test.context.SpringBootTest;
//
//import java.time.LocalDateTime;
//import java.util.List;
//
//@SpringBootTest
//public class JpaCustomerTests {
//    private static final Logger log = LoggerFactory.getLogger(JpaCustomerTests.class);
//    @Autowired
//    private CustomerService customerService;
//    @Autowired
//    private SessionService sessionService;
//    @Autowired
//    private OrderService orderService;
//    @Autowired
//    private CinemaService cinemaService;
//
//    @Test
//    void testOrder() {
//        sessionService.deleteAllSessions();
//        cinemaService.deleteAllCinemas();
//        orderService.deleteAllOrders();
//        customerService.deleteAllCustomers();
//        // 2 кино
//        final Cinema cinema1 = cinemaService.addCinema("Меню");
//        final Cinema cinema2 = cinemaService.addCinema("Аватар");
//
//        // 2 сеанса
//        final Session session1 = sessionService.addSession(300.0,
//                LocalDateTime.now(), cinema1.getId(), 10);
//        final Session session2 = sessionService.addSession( 200.0,
//                LocalDateTime.now(), cinema1.getId(), 10);
//
//        // проверка 2 сеанса у 1 кино
//        Assertions.assertEquals(cinemaService
//                .findCinema(cinema1.getId()).getSessions().size(), 2);
//        // 1 покупатель
//        final Customer customer1 = customerService.addCustomer("Родион", "Иванов");
//        customerService.updateCustomer(customer1.getId(), "Пчел", "Пчелов");
//        Assertions.assertEquals(customerService.findCustomer(customer1.getId()).getLogin(), "Пчел");
//        // 1 заказ, 1 копия заказа
//        final Order order0 = orderService.addOrder(customerService.findCustomer(customer1.getId()).getId());
//        final Order order1 = orderService.findOrder(order0.getId());
//        Assertions.assertEquals(order0, order1);
//
//        // у клиента точно есть заказ?
//        Assertions.assertEquals(customerService
//                .findCustomer(customer1.getId()).getOrders().size(), 1);
//        // 0 заказов
//        orderService.deleteAllOrders();
//        Assertions.assertThrows(OrderNotFoundException.class, () -> orderService.findOrder(-1L));
//        // 2 покупателя
//        final Customer customer2 = customerService.addCustomer("Иннокентий", "Иванов");
//
//        // 1 заказ
//        final Order order2 = orderService
//                .addOrder(customerService.findCustomer(customer2.getId()).getId());
//        // у заказа 2 сеанса
//        orderService.addSession(order2.getId(), session1.getId(), 2);
//
//        List<SessionExtension> result = sessionService.findAllSessions();
//
//        Assertions.assertEquals(sessionService.getCapacity(session1.getId()), 2);
//
//        orderService.addSession(order2.getId(), session2.getId(), 5);
//        Assertions.assertEquals(sessionService.getCapacity(session2.getId()), 5);
//
//        Assertions.assertThrows(IllegalArgumentException.class, () ->
//                orderService.addSession(order2.getId(), session2.getId(), 6));
//
//        // у заказа 1 сеанс
//        orderService.deleteSessionInOrder(order2.getId(), session2.getId(), 10);
//        Assertions.assertEquals(sessionService.getCapacity(session2.getId()), 0);
//        // заполнили всю 2 сессию
//        orderService.addSession(order2.getId(), session2.getId(), 10);
//
//        Assertions.assertEquals(sessionService.findAllSessions().size(), 2);
//
//        orderService.deleteSessionInOrder(order2.getId(), session2.getId(), 4);
//        Assertions.assertEquals(sessionService.getCapacity(session2.getId()), 6);
//        orderService.deleteSessionInOrder(order2.getId(), session2.getId(), 6);
//        Assertions.assertEquals(sessionService.getCapacity(session2.getId()), 0);
//
//        Assertions.assertEquals(orderService.findOrder(order2.getId()).getSessions().size(), 1);
//        Assertions.assertEquals(orderService.findOrder(order2.getId()).getSessions().get(0).getId().getSessionId(), session1.getId());
//
//        // у заказа 1 сеанс
//        // 3 сеанса всего
//        final Session session3 = sessionService.addSession(300.0,
//                LocalDateTime.now(), cinema2.getId(), 10);
//        // удалили заказ2, у которого был сеанс1
//        orderService.deleteOrder(order2.getId());
//        Assertions.assertEquals(orderService.findAllOrders().size(), 0);
//        Assertions.assertEquals(sessionService.findAllSessions().size(), 3);
//
//        // создали 3 заказ у 2 покупателя
//        final Order order3 = orderService
//                .addOrder(customerService.findCustomer(customer2.getId()).getId());
//        orderService.addSession(order3.getId(), session2.getId(), 2);
//        orderService.addSession(order3.getId(), session3.getId(), 8);
//        orderService.addSession(order3.getId(), session1.getId(), 8);
//        // 2-ой покупатель удален
//        // 0 заказов после его удаления
//        Assertions.assertEquals(sessionService.getCapacity(session2.getId()), 2);
//        customerService.deleteCustomer(customer2.getId());
//
//        Assertions.assertThrows(CustomerNotFoundException.class, () -> customerService.findCustomer(customer2.getId()));
//        Assertions.assertThrows(OrderNotFoundException.class, () -> orderService.findOrder(order3.getId()));
//        Assertions.assertEquals(orderService.findAllOrders().size(), 0);
//        Assertions.assertEquals(sessionService.getCapacity(session2.getId()), 0);
//        Assertions.assertEquals(sessionService.getCapacity(session3.getId()), 0);
//
//        Assertions.assertEquals(cinemaService.findAllCinemas().size(), 2);
//        Assertions.assertEquals(sessionService.findAllSessions().size(), 3);
//        // у синема1 1 и 2 сеанс, у синема2 3 сеанс. он удален
//        cinemaService.deleteCinema(cinema2.getId());
//        Assertions.assertEquals(cinemaService.findAllCinemas().size(), 1);
//        Assertions.assertEquals(sessionService.findAllSessions().size(), 2);
//    }
//}
